/*
 * ReplyCode.h
 * Written by rfc959
 */

#ifndef _REPLY_CODE_H_
#define _REPLY_CODE_H_

//Refer to ReplyCode.h


/* Rfc959-Doc  by Firstnumber 1xy is Positive Preliminary reply Codes */ 

#define CODE110 110 // Restart marker reply.
#define CODE120 120 // Service ready in nnn minutes.
#define CODE125 125 // Data connection already open; transfer starting.
#define CODE150 150 // File status okay; about to open data connection.

/* Rfc959-Doc by Firstnumber 2xy is Positive Completion Reply Codes */ 

#define CODE200 200 // Command okay.
#define CODE202 202 // Command not implemented, superfluous at this site.
#define CODE211 211 // System status, or system help reply.
#define CODE212 212 // Directory status
#define CODE213 213 // File status.
#define CODE214 214 // Help message.
#define CODE215 215 // NAME system type.
#define CODE220 220 // Service ready for new user.
#define CODE221 221 // Service closing control connection. Logged out if appropriate.
#define CODE225 225 // Data connection open: no transfer in progress.
#define CODE226 226 // 226 Closing data connection. Requested file action successful 
						  // (for example, filetransfer or file abort).
#define CODE227 227 // Entering Passive Mode (h1,h2,h3,h4,p1,p2).
#define CODE230 230 // User logged in, proceed. 
#define CODE250 250 // Requested file action okay, completed.
#define CODE257 257 // "PATHNAME" created.

/* Rfc959-Doc by Firstnumber 3xy is Positive Intermediate reply Codes  */ 

#define CODE331 331 // User name okay, need password.
#define CODE332 332 // Need account for login.
#define CODE350 350 //350 Requested file action pending further information.

/* Rfc959-Doc by Firstnumber 4xy is Transient Negative Completion reply Codes  */ 

#define CODE421 421 // Service not available, closing control connection.
						  // This may be a reply to any command if the service knows it must shut down.	
#define CODE425 425 // Can't open data connection
#define CODE426 426 // Connection closed; transfer aborted.
#define CODE450 450 // Requested file action not taken.
						  // File unavailable (e.g., file busy).
#define CODE451 451 // Requested action aborted: local error in processing.
#define CODE452 452 // Requested action not taken.
						  // Insufficient storage space in system.

/* Rfc959-Doc by Firstnumber 5xy is Permanent Negative Completion reply Codes  */ 

#define CODE500 500 // Syntax error, command unrecognized
#define CODE501 501 // Syntax error in parameters or arguments.
#define CODE502 502 // Command not implemented.
#define CODE503 503 // Bad sequence of commands.
#define CODE504 504 // Command not implemented for that parameter.
#define CODE530 530 // Not logged in.
#define CODE532 532 // Need account for storing files.
#define CODE550 550 // Requested action not taken.
						  // File unavailable (e.g., file not found, no access).
#define CODE551 551 // Requested action aborted: page type unknown.
#define CODE552 552 // Requested file action aborted.
						  // Exceeded storage allocation (for current directory or dataset).
#define CODE553 553 // Requested action not taken.
						  // File name not allowed.



#endif

