/*
 * ftpclient-MakeDataPort.c
 * written by rfc959
*/

#include <sys/ioctl.h>
#include <net/if.h>
#include "ftpclient.h"
#include <errno.h> /* 2006.12.19_hckang : for errno */


DATAPORT	dataport;

/*********************************************************************************
* Function Name	: MakeSocket
* Return Type		: void
* Arguments			: argv , argc
* Return Value		: 
* 설명				: 소켓 만들기 
* 작성자				: JeonSeokHwan
* *******************************************************************************/
void MakeSocket(char* chpHostName, int nPort)
{
	struct sockaddr_in serv_addr;

	g_sock = socket(PF_INET, SOCK_STREAM , 0);
	if(g_sock == -1)
		error_handling("socket() error");

	memset(&serv_addr, 0 , sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(chpHostName);
	serv_addr.sin_port=htons(g_nPort);

	if(connect(g_sock, (struct sockaddr*)&serv_addr, sizeof(serv_addr)) == -1)
		error_handling("connetc() error!");
	else
		g_stCon.IsConnected = true;
}

/*********************************************************************************
* Function Name : Open_Dataport 
* Return Type	 : 
* Arguments		 : 
* Return Value  : 
* 설명			 : 
* 작성자		    : Mr.Kang
* **********************************************************************************/
void	Open_Dataport(char* chpHostname, int Hostport)
{
	struct	sockaddr_in data_serv_addr;
	
	if ((data_sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
		error_handling("socket() error!");

	memset(&data_serv_addr, 0, sizeof(data_serv_addr));
	data_serv_addr.sin_family = AF_INET;
	data_serv_addr.sin_addr.s_addr = inet_addr(chpHostname);
	data_serv_addr.sin_port = htons(Hostport);

	if (connect(data_sock, (struct sockaddr*)&data_serv_addr, sizeof(data_serv_addr)) < 0)
		error_handling("DataPort connect() error!");
}

/*********************************************************************************
* Function Name : Get_FileSize
* Return Type	 :
* Arguments		 :
* Return Value  :
* 설명			 :
* 작성자		    : Mr.kang
* **********************************************************************************/
size_t	Get_FileSize(char* chpRecvMsg, int nSize)
{
		int nIdx = 0 , nJdx =0;
		char chaFileSize[BUFSIZE];
		size_t nFileSize = 0;

		for(nIdx =0 ; nIdx < nSize-1 ; nIdx++)
		{
			if(chpRecvMsg[nIdx] == ' ')
				break;
		}

		for(nJdx =0 ; chpRecvMsg[nJdx] != '\n' ; nJdx++)
		{
			chaFileSize[nJdx] = chpRecvMsg[nIdx];
			nIdx++;
		}

		nFileSize = atoi(chaFileSize);
				return nFileSize;
}

/*********************************************************************************
* Function Name : port
* Return Type	 : int
* Arguments		 : np1, np2, np3, char* PortMsg
* Return Value  : dump
* 설명			 : 포트 생성하기 ((256 *p1)+p2 )
* 작성자		    : kim_myeung_kyu
* **********************************************************************************/
int port(int nP1 , int nP2, int nP3,char* PortMsg)
{
	int i,j;
	char chaport1[4]={0,};
	char chaport2[4]={0,};

	int nPort1=0;
	int nPort2=0;

	int nResultPort=0;
	
	for(i=0;nP1<nP2-1;i++)
	{
		chaport1[i]=PortMsg[nP1]; 
		nP1++;
	}
	for(j=0;nP2<nP3;j++)
	{
		chaport2[j]=PortMsg[nP2];
		nP2++;
	}
	
	nPort1 = atoi(chaport1);
	nPort2 = atoi(chaport2);

	nResultPort = (nPort1*256) + nPort2;

	return nResultPort;
}

/*********************************************************************
* Function Name : Passing
* Return Type	 : int
* Arguments		 : char* chpRecvMsg,char chaTemp,int nValue
* Return Value  : dump
* 설명			 : 문자 위치
* 작성자		    : kim_myeung_kyu
*********************************************************************/
int Passing(char* chpRecvMsg,char chaTemp,int nValue)
{
	int dump=0;
	
	while(1)
	{
		if(chpRecvMsg[nValue] == chaTemp)
		{
			dump = nValue;
			break;
		}
		nValue++;
	}

	return dump;
}
/*********************************************************************
* Function Name	: Temp_receive
* Return Type	: int
* Arguments		: char* chpRecvMsg, int size
* Return Value  : dump
* 설명			: port시 서버응답을 ','단위로 나누어 출력한다.
* 작성자		:kim_myeung_kyu
*********************************************************************/
int Temp_receive(char* chpRecvMsg)
{
	int nStart=0 , nStart_next=0 , nStart_last=0;
	int nCount = 0;
	int nPort1=0, nPort2=0 , nIpEnd=0;
	int nPort_atoi=0;
	int nPortNum[BUFSIZE]={'\0'};
	int nPasvPort=0;

	while(nCount < PORTCOUNT)
	{
		nStart_next = Passing(chpRecvMsg,',',nStart);
		nStart = nStart_next+1;
		nCount++;
		nPortNum[nCount]=nStart;
	}

	nStart_last = Passing(chpRecvMsg,')',0);

	nPort1 =nPortNum[P1];
	nPort2 =nPortNum[P2];
	nIpEnd =nStart_last;
	nPasvPort = port(nPort1, nPort2, nIpEnd,chpRecvMsg);
	
	return nPasvPort;
}
/*********************************************************************
* Function Name : Disconnect 
* Return Type	 : 
* Arguments		 : 
* Return Value  :
* 설        명  : 연결 안됨
* 작   성   자  : kim_myeung_kyu
*********************************************************************/
void Disconnect()
{
	g_stCon.IsConnected = false;
}

/*********************************************************************
* Function Name : Disconnect 
* Return Type	 : 
* Arguments		 : 
* Return Value  :
* 설        명  : 연결 안됨
* 작   성   자  : kim_myeung_kyu
*********************************************************************/
void CheckLogin(int nValue)
{
	if(nValue == 230)
		g_stCon.IsLogin == true;
	else
		g_stCon.IsLogin == false;
}

/*********************************************************************
* Function Name : myip 
* Return Type	 : char*
* Arguments		 : char *ip
* Return Value  : ip
* 설        명  : 인터넷에 연결된 로컬호스트의 IP를 받아온다
* 작   성   자  : Mr. Kang
*********************************************************************/
char*	myip(char* ip)
{
	const	int	MAX_NIC = 10;
	const	char*	localip = "127.0.0.1"; // 인터넷 연결이 안됐을경우 로컬호스트 ip의 기본값
	struct	ifconf	ifc;
	struct	ifreq		ifr[MAX_NIC];
	int	s;
	int	nNumIFs;
	int	i;
	int	count;
	int	max = 2;
	int	cmd = SIOCGIFCONF;
	max++;

	ifc.ifc_len = sizeof	ifr;
	ifc.ifc_ifcu.ifcu_req = ifr;

	if((s = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		error_handling("local socket() error!");
	}

#if defined(_AIX)
	cmd = CSIOCGIFCONF;
#endif

	if(ioctl(s, cmd, &ifc) < 0)
	{
		error_handling("ioctl error!");
		return	NULL;
	}
	close(s);

	nNumIFs = ifc.ifc_len / sizeof(struct ifreq);
	count = 0;
	strcpy(ip, localip);
	for(i=0 ; i<nNumIFs ; i++)
	{
		struct	in_addr	addr;
		if(ifc.ifc_ifcu.ifcu_req[i].ifr_ifru.ifru_addr.sa_family != AF_INET)
		{
			continue;
		}

		addr = ((struct sockaddr_in *)&ifc.ifc_ifcu.ifcu_req[i].ifr_ifru.ifru_addr)->sin_addr;
		if(addr.s_addr == htonl(0x7f000001))
		{
			continue;
		}
		strcpy(ip, inet_ntoa(addr));
	}

	strcpy(dataport.chaHostip, ip);

	return ip;
}

/*********************************************************************
* Function Name : Replace 
* Return Type	 : 
* Arguments		 : char *ip, char chSrc, chDest
* Return Value  : 
* 설        명  : 입력받은 문자열에서 chSrc를 chDest로 바꾼다
* 작   성   자  : Mr. Kang
*********************************************************************/
void	Replace(char *ip, char chSrc, char chDest)
{
	int	idx = 0;
	char	chaDest[IP_LEN];

	while( *(ip+idx) != '\0' )
	{
		if(*(ip+idx) == chSrc)
			chaDest[idx] = chDest;
		else
			chaDest[idx] = *(ip+idx);
		idx++;
	}
	chaDest[idx] = '\0';
	strcpy(ip, chaDest);
	strcpy(dataport.chaCmdip, ip);
}

/*********************************************************************
* Function Name : Get_hostport
* Return Type	 : 
* Arguments		 : char* chpIp
* Return Value  :
* 설        명  : PORT명령어의 매개변수로 쓸 완전한 하나의 문자열을 만듬
* 작   성   자  : Mr. Kang
*********************************************************************/
void	Get_hostport(char* chpIp)
{
	unsigned short	nPort1 = 0, nPort2 = 0, nPort3 = 0;
	char	chaPort1[BUFSIZE];
	char	chaPort2[BUFSIZE];
	char	chaParseport[BUFSIZE];

	/* 난수발생 초기화(같은값 발생 방지를 위해)  *
	 * srand()함수의 매개변수로  rand()함수 사용 */
	srand(rand()%(time(NULL)));
	
	nPort1 = (random() % 248) + 7;
	nPort2 = random() % 255;
	nPort3 = (nPort1 * 256) + nPort2;
	
	dataport.nport = nPort3;
	sprintf(chaPort1, ",%d", nPort1);
	sprintf(chaPort2, ",%d", nPort2);
	
	strcat(chaPort1, chaPort2);
	strcpy(chaParseport, chaPort1);

	strcat(chpIp,chaParseport);
	strcpy(dataport.chaCmdport, chpIp);

}

/*********************************************************************
* Function Name : Open_ActiveDataport 
* Return Type	 : 
* Arguments		 : 
* Return Value  :
* 설        명  : 데이터포트를 Active_Mode로 연다
* 작   성   자  : Mr. Kang
*********************************************************************/
void	Open_ActiveDataport()
{
	unsigned	int	client_size;
	int	option = 8;
	struct	sockaddr_in active_addr, client_addr;
	socklen_t	optlen;

	optlen = sizeof(option);

	if((data_sock = socket(PF_INET, SOCK_STREAM, 0)) < 0)
		error_handling("socket() error!");

	setsockopt(data_sock, SOL_SOCKET, SO_REUSEADDR, &option, optlen);

	memset(&active_addr, 0, sizeof(active_addr));
	active_addr.sin_family = AF_INET;
	active_addr.sin_addr.s_addr = inet_addr(dataport.chaHostip);
	active_addr.sin_port = htons(dataport.nport);

	if(bind(data_sock, (struct sockaddr*)&active_addr, sizeof(active_addr)) == -1)
	{
		error_handling("bind() error!");
#ifdef	__LINUX_PLATFORM_DEBUG__
		goto error;
#endif
	}
	
	if(listen(data_sock, 1) == -1)
	{
		error_handling("listen() error!");
#ifdef	__LINUX_PLATFORM_DEBUG__
		goto error;
#endif
	}

	client_size = sizeof(client_addr);
	if((dataport.client_sock = accept(data_sock, (struct sockaddr*)&client_addr, &client_size)) == -1)
	{
		error_handling("accept() error!");
#ifdef	__LINUX_PLATFORM_DEBUG__
		goto error;
#endif
	}

#ifdef	__LINUX_PLATFORM_DEBUG__
error:
	if (errno != 0)
	printf(">>> [Open_ActiveDataport] errno=%d\n", errno);
#endif
}

/*********************************************************************
* Function Name : exec_port() 
* Return Type	 : 
* Arguments		 : char* chpIp
* Return Value  :
* 설        명  : 
* 작   성   자  : Mr. Kang
*********************************************************************/
void exec_port()
{
	char* chpIp;

	chpIp = (char*)malloc(sizeof(char)*PORT_LEN);
	memset(chpIp, 0, PORT_LEN);
	
	myip(chpIp);
	Replace(chpIp, '.', ',');
	Get_hostport(chpIp);

	free(chpIp);
}
