/*
 * ftpclient-begin.c
 * Written by rfc959a
 */

#include "ftpclient.h"
#include "ftpclient-func.h"
#include "ftpclient-cmdlist.h"

/*********************/
/*       GLOBAL      */
/*********************/

int (*cmdfun[CMD_MAX])(FuncArg* pArg);  /* 2006.12.21 jun MAX_FUNC --->         CMD_MAX  */

/*********************************************************************
* Function Name	: PutCmd_Begin
* Return Type		: void
* Arguments			: char
* Return Value		: chaSendCommand  
* 설명				: 모든 명령어를 받는 함수
* 작성자				: JeonSeokHwan
* *******************************************************************/
void PutCmd_Begin()
{
	/* 입력받은 데이터 */
	char	chaUserInput[USER_INPUT_LEN] = {0,};	/* 2006.12.13_shahn for user input parsing */	
	char	*chpTok;

	FuncArg	fArg;

	char chaGetCommanTemp[BUFSIZE] = {0,};
	char chaGetFrontPassRes[BUFSIZE] = {0,};
	char chaFrontReturn[BUFSIZE] = {0,};
	char chaArgvData[BUFSIZE] = {0,}; /*파싱할 데이터 */
	
	int	nCmd, nRvCode = 0;
	
	char	chaCmd[USER_INPUT_LEN] = {0,}; 
	char	chaArgs[USER_INPUT_LEN] = {0,};
	char	*chpFind;


	printf("ftp > ");
	
	fgets(chaUserInput, USER_INPUT_LEN, stdin);
	
   /* 엔터키만 입력 */
	if(strcmp(chaUserInput, "\n") == 0 )
		return;
	
	chpFind = strrchr(chaUserInput, '\n');	/* 2006.12.13_shahn : delete newline */
	if(chpFind != NULL)
		*chpFind = '\0';

	/* 분리된 명령어 및 args들에 대해 공백이 남아있는지 check할 것 
	 * mget과 같은 경우는 args들이 많을 수 있는데, 이 때 args 사이의 공백 check는 하지 않음
	 * 1. cmd 앞뒤로 공백 check
	 * 2. args 앞 뒤로 공백 check (args 사이의 공백은 유지할 것
	 * 3. check된 공백들은 모두 제거할 것
	 */
	
	
	chpFind = strchr(chaUserInput, ' ');

	if(chpFind == NULL)
	{
		strcpy(chaCmd, chaUserInput);
		fArg.chpPassData = (char*)malloc(sizeof(char)*(SPACE_SIZE+1));	/* 2006.12.15_shahn : strlen(chpFind) 제거-chpFind is NULL  */
		strcpy(fArg.chpPassData, "");
	}	
	else
	{
		strncpy(chaCmd, chaUserInput, chpFind-chaUserInput);
		fArg.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpFind+SPACE_SIZE)+1));
		/* pArg->chpPassData는 이 함수내에서 free하지 말것. 각 command 함수 안에서 free함. FreeArg() 참고 */
		strcpy(fArg.chpPassData, chpFind+SPACE_SIZE);
		
	}

	strchr(chaCmd, ' ');
   nCmd = cmdlist(chaCmd);

	if(nCmd == INVALID_CMD)
	{
		printf("?Invalid command\n");
		return ;
	}
	else
	{
		nRvCode = cmdfun[nCmd+1](&fArg);
	}

}

/*********************************************************************
* Function Name	: SendCommand
* Return Type		: void
* Arguments			: chpFtpCmd(명령어) , chpArgv(인자)
* Return Value		: 
* 설명				: 명령어 보내기 
* 작성자				: JeonSeokHwan
* *******************************************************************/
void SendCommand(char* chpFtpCmd , char* chpArgv )
{
	char chaSendCmd[BUFSIZE] = {0,};

	if( (chpFtpCmd == NULL) || (chpArgv == NULL))	/* 2006.12.12_shahn : pointer null check */
	{
		error_handling(">>> [SendCommand()] Data is NULL \n");
	}
	
	sprintf(chaSendCmd, "%s %s\r\n", chpFtpCmd, chpArgv);
	write(g_sock , chaSendCmd , strlen(chaSendCmd));
}

/*********************************************************************
* Function Name	: SetCmdFunc
* Return Type		: int
* Arguments			: 
* Return Value		:  
* 설명				: 함수 포인터 리스트
* 작성자				: kim-myeung-kyu
* *******************************************************************/
int SetCmdFunc()
{
	cmdfun[CMD_CD] = cmd_cd;
	cmdfun[CMD_CDUP] = cmd_cdup;
	cmdfun[CMD_LS] = cmd_ls;
	cmdfun[CMD_DIR] = cmd_dir;
	cmdfun[CMD_PWD] = cmd_pwd;
	cmdfun[CMD_HELP] = cmd_help;
	cmdfun[CMD_BINARY] = cmd_binary;
	cmdfun[CMD_ASCII] = cmd_ascii;
	cmdfun[CMD_GET] = cmd_get;
	cmdfun[CMD_PUT] = cmd_put;  //10
	cmdfun[CMD_DEL] = cmd_delete;
	cmdfun[CMD_MGET] = cmd_mget;
	cmdfun[CMD_MPUT] = cmd_mput;
	cmdfun[CMD_MDEL] = cmd_mdelete;
	cmdfun[CMD_RENAME] = cmd_rename;
	cmdfun[CMD_MKDIR] = cmd_mkdir;
	cmdfun[CMD_RMDIR] = cmd_rmdir;
	cmdfun[CMD_STATUS] = cmd_status;
	cmdfun[CMD_SIZE] = cmd_size;
	cmdfun[CMD_BYE] = cmd_bye;  //20
	cmdfun[CMD_EXIT] = cmd_exit;
	cmdfun[CMD_QUIT] = cmd_quit;
	cmdfun[CMD_CLOSE] = cmd_close;
	cmdfun[CMD_NLST] = cmd_nlist;
	cmdfun[CMD_OPEN] = cmd_open;
	cmdfun[CMD_LCD] = cmd_lcd;
	cmdfun[CMD_ERR] = cmd_err;
	cmdfun[CMD_HASH] = cmd_hash;  
	cmdfun[CMD_PROMPT] = cmd_prompt;	//29
	cmdfun[CMD_USER] = cmd_user;
}
