/*
 * ftpclient-cmdfunc.c
 * Written by rfc959a
 */

/* 2006.12.15_shahn : 
 * 1. 각 command 함수의 return 값 정의할 것  */

#include <sys/stat.h>
#include <dirent.h>
#include <fnmatch.h>
#include "ftpclient.h"
#include "ftpclient-func.h"

extern	DATAPORT dataport;

/* [[2006.12.15_jun]] 
modify files :
	
cmdlist-rmt.txt & ftpclient-cmdlist.h add (function list)
	
ftpclient-begin.c ->SetCmdFunc() modify 
*/

/*******************************************************************
* Function Name	: cmd_cd();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 디렉토리 이동
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_cd(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("CWD", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_cdup();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 상위디렉토리로 이동
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_cdup(FuncArg* pArg )
{	
	int nRvCode = 0;

	SendCommand("CDUP", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);

	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_ls();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 리스트 명령어 실행
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_ls(FuncArg* pArg)
{
	int nRvCode = 0;

	exec_port();
	SendCommand("PORT", dataport.chaCmdport);
	nRvCode = socket_recv();
	
	if(nRvCode == 200)
	{
		SendCommand("LIST", pArg->chpPassData);
		Open_ActiveDataport();
		nRvCode = socket_recv();
	}
	else
		return nRvCode;

	/* data port 가 열렸다면 */
	if(nRvCode == 150)
	{
		recv_data();
	}
	else
	{
		return nRvCode;
	}
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_dir();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 리스트 명령어 실행
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_dir(FuncArg* pArg)
{	
	int nRvCode = 0;
	
	exec_port();

	SendCommand("PORT", dataport.chaCmdport);
	nRvCode = socket_recv();

	if(nRvCode == 200)
	{
		SendCommand("LIST","");// pArg->chpPassData);
		Open_ActiveDataport();
		nRvCode = socket_recv();
	}
	else 
		return nRvCode;

	/* data port 가 열렸다면 */
	if(nRvCode == 150)
	{
		recv_data();
	}
	else
	{
		return nRvCode;
	}
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_pwd();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 서버의 현재 위치한 Pathname 보기
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_pwd(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("PWD", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_help();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 도움말 보기
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_help(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("HELP", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_binary();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: Type을 binary모드로 변경
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_binary(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("TYPE I", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_ascii();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: Type을 ascii모드로 변경
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_ascii(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("TYPE A", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_get();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 파일받기(다운로드)
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_get(FuncArg* pArg)
{
	int nRvCode = 0;
	int nFilesize =0;	

	exec_port();
	
	SendCommand("SIZE" , pArg->chpPassData);
	nFilesize = socket_recv();
	nRvCode = nFilesize;

	/* 파일 사이즈가 0 이면 */
	if(nFilesize==0 || nRvCode == 550)
	{
	//	printf("usage: %s is size %d\n",pArg->chpPassData, nFilesize);
		return NOT_FILE;
	}

	SendCommand("PORT", dataport.chaCmdport);
	nRvCode = socket_recv();
	SendCommand("RETR", pArg->chpPassData);
	Open_ActiveDataport();
	nRvCode = socket_recv();
		
	/* data port 가 열렸다면 */
	if(nRvCode == 150)
	{
		recv_file(nFilesize , pArg->chpPassData);
	}
	else
	{
		return nRvCode;
	}

	nRvCode = socket_recv();
	FreeArg(pArg);
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_put();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 파일 올리기(업로드)
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_put(FuncArg* pArg)               
{	
	int nRvCode = 0;

	exec_port();
	SendCommand("PORT", dataport.chaCmdport);
	nRvCode = socket_recv();

	/* 만약 현재디렉토리에 파일이 없다면 */
	if(pArg->chpPassData=='\0')
	{
		return NOT_FILE;
	}
	else if(access(pArg->chpPassData , F_OK) != 0)
	{
		perror("usage");
		return NOT_FILE;
	}
		
	/* 파일이 있다면 */
	if(nRvCode == 200)
	{
		SendCommand("STOR", pArg->chpPassData);
		Open_ActiveDataport();
		nRvCode = socket_recv();
	}
	else 
		return nRvCode;
	
	/* data port 가 열렸다면 */
	if(nRvCode == 150)
	{
		send_file(pArg->chpPassData);
	}
	else
	{
		return nRvCode;
	}
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_delete();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 파일 삭제
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_delete(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("DELE", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}
/*******************************************************************
* Function Name	: cmd_mget();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 멀티 다운로드(한번의 명령으로 여러개의 파일을 받음)
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_mget(FuncArg* pArg)
{	
	int nRvCode = 0;
	char*	pBuf, *pBufCpy, *pArgsCpy;
	char* chpTokArg, *chpTokRcv, *chpSaveArg, *chpSaveRcv;
	FuncArg	ArgNlist;

	exec_port();

	pBuf = (char*)malloc(sizeof(char*)*FLIST_BUF);
	memset(pBuf, 0, FLIST_BUF); /* hckang 쓰레기값 들어가는것을 막음 */

	pBufCpy = pBuf;	/* strotk_r 실행시 pBuf가 NULL이 되기 땜시 addr 저장 */
	
	while( (chpTokArg = strtok_r(pArg->chpPassData, " ",&chpSaveArg)) != NULL)
	{
		ArgNlist.nArg = NLIST_SAVEDATA;
		ArgNlist.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpTokArg)+1));
		strcpy(ArgNlist.chpPassData, chpTokArg);

		ArgNlist.chpRetData = pBuf;

		cmd_nlist(&ArgNlist);

		pArg->chpPassData = NULL;	/* shahn : strtok_r 과 관련 manpage 참고 */

#ifdef	__LINUX_PLATFORM_DEBUG__
		printf(">>> file list >>>\n%s\n\n", pBuf);
#endif
		
		while( (chpTokRcv=strtok_r(pBuf, "\r\n", &chpSaveRcv)) != NULL)
		{
			int	nCnt;
			int	nGet = 0;
			FuncArg getArg;

			getArg.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpTokRcv)+1));	
			strcpy(getArg.chpPassData, chpTokRcv);	
			
#ifdef	__LINUX_PLATFORM_DEBUG__
			printf(">>> Tocked file Name : %s\n", chpTokRcv);
#endif
			/* prompt */
			if( (dataport.chMode & MODE_PROMPT_ON) == MODE_PROMPT_ON)
			{
				printf("%s [y/n]?", chpTokRcv);
				nGet = getchar();
				if( (nGet == (int)'n') || (nGet == (int)'N'))
				{
					getchar();	/* 2006.12.22_shahn : read new line */
					pBuf = NULL;
					continue;
				}
				if(nGet != '\n')
					getchar();	/* 2006.12.22_shahn : read new line */
			}
			cmd_get(&getArg);

			pBuf = NULL;
		}

		if(pBuf == NULL)
			pBuf = pBufCpy;	/* strtok_r 실행이후 pBuf에는 NULL 이 들어감 : strtok_r에 대한 man page확인 */ 
		memset(pBuf, 0, FLIST_BUF);
	}
	if(pBufCpy != NULL)
		free(pBufCpy);
	FreeArg(pArg);
	return 0;
}

/*******************************************************************
* Function Name	: cmd_mput();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 멀티 업로드(한번의 명령으로 여러개의 파일을 업로드)
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_mput(FuncArg* pArg)
{
	char* chpLocaldir;
	char* chpTemp;
	int nRvCode = 0;
	char*	pBuf, *pBufCpy, *pArgsCpy;
	char* chpTokArg, *chpTokRcv, *chpSaveArg, *chpSaveRcv;
	FuncArg	ArgNlist;
	
	pBuf = (char*)malloc(sizeof(char*)*FLIST_BUF);
   pBufCpy = pBuf;	/* strotk_r 실행시 pBuf가 NULL이 되기 땜시 addr 저장 */
	
	while( (chpTokArg = strtok_r(pArg->chpPassData," ",&chpSaveArg)) != NULL)//공백 단위로 데이터를 파싱한다... ㅡ.,ㅡ
		{
		ArgNlist.nArg = NLIST_SAVEDATA;
		ArgNlist.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpTokArg)+1));
		strcpy(ArgNlist.chpPassData, chpTokArg);
		
		ArgNlist.chpRetData = pBuf;
		Local_nList(&ArgNlist);
		pArg->chpPassData = NULL;	/* shahn : strtok_r 과 관련 manpage 참고 */
		
#ifdef	__LINUX_PLATFORM_DEBUG__
		printf(">>>>>> file list >>>>>>\n%s\n", pBuf);
#endif
		while((chpTokRcv=strtok_r(pBuf, "\n", &chpSaveRcv)) != NULL)
		{
			int	nCnt;
			int	nGet = 0;
			FuncArg getArg;

			
			getArg.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpTokRcv)+1));	
			strcpy(getArg.chpPassData, chpTokRcv);	
			
#ifdef	__LINUX_PLATFORM_DEBUG__
			printf(">>>>>> put file Name : %s\n", chpTokRcv);
#endif
			/* prompt */
			if( (dataport.chMode & MODE_PROMPT_ON) == MODE_PROMPT_ON)
			{
				printf("%s [y/n]?", chpTokRcv);
				nGet = getchar();
				if( (nGet == (int)'n') || (nGet == (int)'N'))
				{
					getchar();	/* 2006.12.22_shahn : read new line */
					pBuf = NULL;
					continue;
				}
				if(nGet != '\n')
					getchar();	/* 2006.12.22_shahn : read new line */
			}
			cmd_put(&getArg);
			pBuf = NULL;
		}
		
		if(pBuf == NULL)
			pBuf = pBufCpy;	/* strtok_r 실행이후 pBuf에는 NULL 이 들어감 : strtok_r에 대한 man page확인 */ 
		memset(pBuf, 0, FLIST_BUF);
		
	}
	if(pBufCpy != NULL)
		free(pBufCpy);
	FreeArg(pArg);
	return 0;
}

/*******************************************************************
* Function Name	: cmd_mdelete();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 멀티 파일삭제(한번의 명령으로 여러개의 파일삭제)
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_mdelete(FuncArg* pArg)
{	
	int nRvCode = 0;
	char*	pBuf, *pBufCpy, *pArgsCpy;
	char* chpTokArg, *chpTokRcv, *chpSaveArg, *chpSaveRcv;
	FuncArg	ArgNlist;

	exec_port();
	pBuf = (char*)malloc(sizeof(char*)*FLIST_BUF);
	pBufCpy = pBuf;	/* strotk_r 실행시 pBuf가 NULL이 되기 땜시 addr 저장 */
	
	while( (chpTokArg = strtok_r(pArg->chpPassData, " ",&chpSaveArg)) != NULL)
	{
		ArgNlist.nArg = NLIST_SAVEDATA;
		ArgNlist.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpTokArg)+1));
		strcpy(ArgNlist.chpPassData, chpTokArg);

		ArgNlist.chpRetData = pBuf;
		
		cmd_nlist(&ArgNlist);

		pArg->chpPassData = NULL;	/* shahn : strtok_r 과 관련 manpage 참고 */

#ifdef	__LINUX_PLATFORM_DEBUG__
		printf(">>>>>> file list >>>>>>\n%s\n", pBuf);
#endif

		
		while( (chpTokRcv=strtok_r(pBuf, "\r\n", &chpSaveRcv)) != NULL)
		{
			int	nCnt;
			FuncArg getArg;

			getArg.chpPassData = (char*)malloc(sizeof(char)*(strlen(chpTokRcv)+1));	
			strcpy(getArg.chpPassData, chpTokRcv);	
			
#ifdef	__LINUX_PLATFORM_DEBUG__
			printf(">>>>>> get file Name : %s\n", chpTokRcv);
#endif
			cmd_delete(&getArg);
			pBuf = NULL;
		}
		
		if(pBuf == NULL)
			pBuf = pBufCpy;	/* strtok_r 실행이후 pBuf에는 NULL 이 들어감 : strtok_r에 대한 man page확인 */ 
		memset(pBuf, 0, FLIST_BUF);
	}
	if(pBufCpy != NULL)
		free(pBufCpy);
	FreeArg(pArg);
	return 0;
}

/*******************************************************************
* Function Name	: cmd_rename();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 파일 또는 디렉토리의 이름 변경
* 작성자				: Mr. Kang
* ******************************************************************/
int cmd_rename(FuncArg* pArg)
{
	int	nRvCode = 0;
	char*	chpRnfr;
	char*	chpRnto;
	
	chpRnfr = strtok(pArg->chpPassData," ");
	chpRnto = strtok(NULL, " ");
	if(chpRnto == NULL)
	{
		printf("rename from-name to-name\n");
		return 0;
	}

	SendCommand("RNFR", chpRnfr);
	nRvCode = socket_recv();

	if (nRvCode == 350)
		SendCommand("RNTO", chpRnto);
	else
		return nRvCode;

	nRvCode = socket_recv();

	FreeArg(pArg);
	return nRvCode;	
}
/*******************************************************************
* Function Name	: cmd_mkdir();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 디렉토리 생성
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_mkdir(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("MKD", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_rmdir();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 디렉토리 삭제
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_rmdir(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("RMD", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg); /* 20061219_hckang 추가 */
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_status();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 현재 접속 정보를 보여줌
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_status(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("STAT", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}


/*******************************************************************
* Function Name	: cmd_size();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 파일의 사이즈를 체크
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_size(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("SIZE", pArg->chpPassData);
	nRvCode = socket_recv();
	
	FreeArg(pArg);
	return nRvCode;
}


/*******************************************************************
* Function Name	: cmd_bye();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 접속종료
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_bye(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("QUIT", pArg->chpPassData);
	nRvCode = socket_recv();
	close(g_sock);
	
	FreeArg(pArg);
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_exit();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 접속종료
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_exit(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("QUIT", pArg->chpPassData);
	nRvCode = socket_recv();
	close(g_sock);
	
	FreeArg(pArg);
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_quit();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 접속종료
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_quit(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("QUIT", pArg->chpPassData);
	nRvCode = socket_recv();
	close(g_sock);
	
	FreeArg(pArg);
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_close();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 접속종료
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_close(FuncArg* pArg)
{	
	int nRvCode = 0;

	SendCommand("QUIT", pArg->chpPassData);
	nRvCode = socket_recv();
	close(g_sock);
	
	FreeArg(pArg);
	return 0;
}

/*******************************************************************
* Function Name	: cmd_nlist();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: 리스트 명령어 실행 - mget의 전처리과정
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_nlist(FuncArg* pArg)
{	
	int nRvCode = 0;

	exec_port();
	SendCommand("PORT", dataport.chaCmdport);
	nRvCode = socket_recv();
	SendCommand("NLST", pArg->chpPassData);
	Open_ActiveDataport();
	nRvCode = socket_recv();	
	
	// data port 가 열렸다면
   if(nRvCode == 150)	
	{
		switch(pArg->nArg)
		{
			case NLIST_DISPLAY:
				recv_data();
				break;
			case NLIST_SAVEDATA:
				if(pArg->chpRetData == NULL)
					return -1;
				recv_list(pArg->chpRetData);

				break;
			default:
				break;
		}
	}
	else
	{
		return nRvCode;
	}

	nRvCode = socket_recv();
	FreeArg(pArg);
	return nRvCode;
}

/*******************************************************************
* Function Name	: cmd_err();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 존재하지 않는 명령어 입력시 실행
* 작성자				: jeon seokhwan
* ******************************************************************/
int cmd_err(FuncArg* pArg)
{
	printf("BAD COMMAND");
	FreeArg(pArg);
}


int FreeArg(FuncArg* pArg)
{
	if(pArg->chpPassData != NULL)
		free(pArg->chpPassData);
	pArg->chpPassData = NULL;
	pArg->nArg = 0;	/* default value */
}
/*******************************************************************
* Function Name	: char* Local_nList();
* Return Type		: char*
* Arguments			: FuncArg* pArg
* Return Value		: pstData->d_name
* 설명				: 클라이언트의 파일을 와일드카드(필터링)로 검색
* 작성자				: Mr. Kang
* ******************************************************************/
char* Local_nList(FuncArg* pArg)
{
	DIR*		pDir;
	char		chaArg[FILE_LEN] = {0,};
	char		chaDir[FILE_LEN];
	struct	dirent*	pstData = NULL;
	struct	stat		file_stat;

	
	getcwd(chaDir, FILE_LEN); /* 현재 위치한 디렉토리명을 찾음 */

		if((pDir = opendir(chaDir)) == NULL)
		{
			printf("open directory error\n");
			return NULL;
		}

		memset(pArg->chpRetData, 0, FLIST_BUF); 
	
		while(pstData = readdir(pDir))
		{
			/* 숨김파일은 검색에서 제외한다 */
			if(strncmp(pstData->d_name, ".", 1) == 0)
				continue;
			/* 디렉토리내의 파일 정보를 가져온다 */
			if(stat(pstData->d_name, &file_stat) < 0)
				;
			/* 찾아낸 값이 디렉토리인지 파일인지 비교 */
			if(!S_ISDIR(file_stat.st_mode))
			{
				/* 입력한 문자열에 의한 필터링으로 조건에 만족하는 값만 찾음 */
				if((fnmatch(pArg->chpPassData, pstData->d_name, 0)) != FNM_NOMATCH)
				{
					strcat(pArg->chpRetData, pstData->d_name);
					pArg->chpRetData[strlen(pArg->chpRetData)] = '\n';
				}
		}
}
	pArg->chpRetData[strlen(pArg->chpRetData)+1] = '\0';
	closedir(pDir);
	return pstData->d_name;
}

/*******************************************************************
* Function Name	: cmd_hash();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 파일전송상태를 1024byte마다 '#'으로 표시
* 작성자				: kim_myeung_kyu
* ******************************************************************/
int cmd_hash(FuncArg* pArg)
{
	char	chaMsg[8];
	
	if( (dataport.chMode & MODE_HASH_ON) == MODE_HASH_ON )
	{
		dataport.chMode &= ~MODE_HASH_ON;
		strcpy(chaMsg, "off");
	}
	else
	{
		dataport.chMode |= MODE_HASH_ON;
		strcpy(chaMsg, "on");
	}

	printf("hash %s\n", chaMsg);
	
	FreeArg(pArg);
	return NO_ERR;

}
/*******************************************************************
* Function Name	: cmd_open();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 인자값없이 ftp실행했을 경우 open명령으로 소켓연결
* 작성자				: Mr. Kang
* ******************************************************************/
int cmd_open(FuncArg* pArg)
{
	char*	chpHostName;
	char* chpPort;

	chpHostName = strtok(pArg->chpPassData," ");
	chpPort = strtok(NULL, " ");

	if(chpHostName == NULL)
	{
		printf("open host-ip port\n");
		FreeArg(pArg);
		return  0;
	}
	
	if(chpPort == NULL)
		g_nPort = 21;
	else
		g_nPort = atoi(chpPort);

	MakeSocket(chpHostName, g_nPort);

	FtpLogin();

	FreeArg(pArg);
	return 0;	
}

/*******************************************************************
* Function Name	: cmd_lcd();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 클라이언트의 현재 Pathname을 보여줌
* 작성자				: Mr. Kang
* ******************************************************************/
int cmd_lcd(FuncArg* pArg)
{
	char chaLcd[FILE_LEN];

	getcwd(chaLcd, FILE_LEN);
	printf("Local directory now %s\n",chaLcd);

	FreeArg(pArg);
	return 0;
}
/*******************************************************************
* Function Name	: cmd_prompt();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: 
* 설명				: 
* 작성자				: 
* ******************************************************************/

int cmd_prompt(FuncArg* pArg)
{
	char	chaMsg[8]={0,};

	if( (dataport.chMode & MODE_PROMPT_ON) == MODE_PROMPT_ON )
	{
		dataport.chMode &= ~MODE_PROMPT_ON;
		strcpy(chaMsg, "off");
	}
	else
	{
		dataport.chMode |= MODE_PROMPT_ON;
		strcpy(chaMsg, "on");
	}

//	printf("dataport.chMode=%d\n", dataport.chMode);	/* test code */
	printf("prompt %s\n", chaMsg);
	
	FreeArg(pArg);

	return NO_ERR;
}

/*******************************************************************
* Function Name	: cmd_user();
* Return Type		: int
* Arguments			: FuncArg* pArg
* Return Value		: nRvCode
* 설명				: user명령어를 통한 로그인
* 작성자				: Mr, Kang
* ******************************************************************/
int cmd_user(FuncArg* pArg)
{
	int	nRvCode = 0;
	char*	chpPasswd;

	SendCommand("USER", pArg->chpPassData);
printf("[%s]\n", pArg->chpPassData);
	nRvCode = socket_recv();

	if(nRvCode == 331)
	{
		chpPasswd = getpass("[passwd]:");
		SendCommand("PASS", chpPasswd);
		nRvCode = socket_recv();
	}

	if(nRvCode == 230)
	{
		if(strcmp(pArg->chpPassData, "anonymous") == 0)
			nRvCode = socket_recv();
		SendCommand("SYST", "");
		nRvCode = socket_recv();
	}

	if(nRvCode == 215)
	{
		SendCommand("TYPE I", "");
		nRvCode = socket_recv();
	}

	FreeArg(pArg);

	return nRvCode;
}
