/*
 * ftpclient-login.c
 * written by rfc959
*/

#include "ftpclient.h"
#include "ReplyCode.h"

/*********************************************************************************
* Function Name	: error_handling
* Return Type	: void
* Arguments		: char
* Return Value  : 
* 설명			: 에러발생시 처리 , 프로그램 종료
* 작성자		: JeonSeokHwan
* **********************************************************************************/
void error_handling(char *message)
{
	fputs(message , stderr);
	fputc('\n' , stderr);
//	exit(1);
}

/*********************************************************************************
* Function Name	: FtpLogin
* Return Type		: void
* Arguments			: chpGetMsg
* Return Value		: 
* 설명				: 로그인 하기 
* 작성자				: JeonSeokHwan
* *******************************************************************************/
void FtpLogin()
{
	int nRvCode =0 , nSendVal =0;
	int	i= 0;
	char* chpLoginData;
	char	chaTempData[BUFSIZE]={0,};
	char*	chpPasswd;
	char*	LogList[]={"" , "USER" , "PASS" , "SYST" , "TYPE I"};
	
	chpLoginData = (char*)malloc(sizeof(char)*BUFSIZE);

	while(1)
	{
		memset(chpLoginData , 0 , BUFSIZE);
		nRvCode = socket_recv();

		switch(nRvCode)
		{
			case CODE220:
				printf("[user]:");
				fgets(chpLoginData, BUFSIZE, stdin);
				strcpy(chaTempData, chpLoginData);
				nSendVal =1;
				break;
			case CODE331:
				chpPasswd = getpass("[passwd]:");
				nSendVal =2;
				break;
			case CODE230:
				nSendVal =3;
				if(strcmp(chaTempData, "anonymous\n") == 0)		/* 2007.1.2 입력한 ID가 anonymous면 */
					;//nRvCode = socket_recv();
				break;
			case CODE215:
				nSendVal =4;
				break;
			default :
				nSendVal = -1;
		}

		if(nSendVal == -1)
			break;
		
		if(nSendVal == 2)
			SendCommand(LogList[nSendVal], chpPasswd);
		else
			SendCommand(LogList[nSendVal], chpLoginData);
	}
	free(chpLoginData);
}
