/*
 * ftpclient-recv.c
 * written by rfc959
*/

#include "ftpclient.h"
#include "ReplyCode.h"

extern	DATAPORT	dataport;

/*********************************************************************************
* Function Name	: ReceiveFirstline
* Return Type		: char
* Arguments			: chpReceiveData
* Return Value		: chpReturnData
* 설명				: 받은 메세지가 한줄일때 처리 ex)user a => user뒤 <sp>이면 while문을 나감 
* 작성자				: JeonSeokHwan
* *******************************************************************************/
char* ReceiveCode(char *chpReceiveData , char *chpReturnData)
{
	int nidx =0;

	memset(chpReturnData , 0 , sizeof(chpReturnData));

	for(nidx = 0 ; nidx < 4 ; nidx++)
	{
		chpReturnData[nidx] = chpReceiveData[nidx];
	}
	
	return chpReturnData;
}

/*********************************************************************************
* Function Name	: sock_recv
* Return Type		: int
* Arguments			: 
* Return Value		: Receive Code Value
* 설명				: 메세지 받기 
* 작성자				: JeonSeokHwan
* *******************************************************************************/
#define	BUF_LEN	2048	
int  socket_recv()
{
	int total_receive=0 , receive=0; 
	int nidx =0 , njdx=0; 
	int nRow =0 , nSeveralRow = 0;
	int loop =0 , loop_i=0;
	int chaRowNum[BUFSIZE];
	int nRvCode =0;

	char chaCompareCode_firstline[BUF_LEN] = {0,};
	char chaCompareCode_lastline[BUF_LEN] = {0,};
	char chaFirstLine[BUF_LEN] = {0,};
	char chaTempData[BUF_LEN] = {0,};
	char message[BUF_LEN];

	/*[[ 20070103 : anonymous  */	
	bool	nFlag = true;
	/*}} 20070103 : anonymous  */	


	do	
	{
		memset(message , 0 ,BUF_LEN);
		g_nRecv = recv(g_sock , message , BUF_LEN , 0);

	/*[[ 20070103 : anonymous  */	
		if(nFlag == true)
		{
			strncpy(chaFirstLine , ReceiveCode(message , chaTempData), 3);/* 받은 메세지에서 코드 받아 오기  */
			strcat(chaFirstLine, " ");
			chaFirstLine[4] = '\0';
			nFlag = false;
		}
	/*]] 20070103 : anonymous  */	

		for(nidx =0 ; nidx < g_nRecv ; nidx++)
		{
			if(message[nidx]=='\n')
			{
				nRow++; /* 줄단위 */ 
				if(nRow == 1)
				{
					strncpy(chaCompareCode_lastline , message , 3);/*마지막줄 코드 받아오기 */
				}
				nSeveralRow = nRow-1;
				chaRowNum[nRow] = nidx;
			}
		}
		
		total_receive += g_nRecv;
		printf("%s",message);
		
		loop = chaRowNum[nRow];

		if(nSeveralRow ==0) /* 받아오는 메세지가 한줄 이라면 */
		{
			loop_i =0;
		}
		else /* 받아오는 메세지가 두줄 이상일때 */
		{
			loop_i = chaRowNum[nSeveralRow];
		}
					
		for(njdx=0 ; njdx < 3 ; njdx++)
		{
			loop_i++;
			chaCompareCode_firstline[njdx] = message[loop_i]; /* 첫째줄 코드 받아오기 */
		}		
#define	STR_MATCH	0	

		/*[[ 20070103 : anonymous  */	
		if( strstr(message, chaFirstLine) != NULL ) /* Addeded part for anonymous */
		{
			break;
		}
#if 0								/* deleted part for anonymous */
		if(chaFirstLine[3] ==' ') /* 첫줄일때 코드뒤 자리가 ' '(공백이면 수신종료) */
		{
			break;
		}
		else if(strcmp(chaCompareCode_lastline , chaCompareCode_firstline) == 0) /* 여러줄일때 첫줄과 마지막줄 코드가 같으면 수신종료 */
		{
			break;
		}
		
//		else if(chaFirstLine[3] == '-')
//		{
//			break;
//		}
#endif		
		/*]] 20070103 : anonymous  */	
	}while((g_nRecv != RCV_ERROR) && (g_nRecv != NOT_RCV));

	nRvCode = GetRvCode(chaFirstLine , message);

	return nRvCode;
}

/*********************************************************************************
* Function Name	: GetRvCode
* Return Type		: int
* Arguments			: GetMsg(받은 메세지)
* Return Value		: CODE Number
* 설명				: 받은 메세지에서 코드값을 이용하여 처리 
* 작성자				: JeonSeokHwan
* *******************************************************************************/
int GetRvCode(char *GetFsLine , char *GetMsg)
{	
	int nRvCode = 0;
	int nFilesize =0;
	int nGet_Hostport =0;
	
	nRvCode = atoi(GetFsLine);

	switch (nRvCode)
	{
		case CODE213 : //Refer to ReplyCode.h
		{
			nFilesize = Get_FileSize(GetMsg,g_nRecv);
			return nFilesize;
		}
		case CODE221 : //Refer to ReplyCode.h
		{
			close(g_sock);
			exit(1);
		}
			break;
//		case CODE200 : //Refer to ReplyCode.h
//		{
//			return CODE200;
//		}
//			break;
		default :
			return nRvCode;
			break;
	}
}

/*********************************************************************************
* Function Name	: RecvReply
* Return Type		: char
* Arguments			: 
* Return Value		: chpRecvCode
* 설명				: Login을 위한 응답메세지
* 작성자				: JeonSeokHwan
* *******************************************************************************/
char*  RecvReply(char* chpRecvCode)
{
	char chaRecvMsg[BUFSIZE];
	int str_len = 0;

	memset(chpRecvCode , 0 , sizeof(chpRecvCode));
	
	str_len = recv(g_sock , chaRecvMsg, BUFSIZE , 0);

#ifdef	__LINUX_PLATFORM_DEBUG__
	printf(">>> [%s:RecvReply] %d line >> str_len : %d \n", __FILE__, __LINE__, str_len);
#endif
	
	chaRecvMsg[str_len]=0;
	printf("%s" , chaRecvMsg);
	strcpy(chpRecvCode , chaRecvMsg);

	return chpRecvCode;
}

/*********************************************************************************
* Function Name	: recv_data
* Return Type		: 
* Arguments			: 
* Return Value		: 
* 설명				: 서버로 부터 데이터 받아오기
* 작성자				: JeonSeokHwan
* *******************************************************************************/
void	recv_data()
{
	int	nStrlen = 0;
	char	chaDatabuf[BUFSIZE] = {0,};

	do
	{
		nStrlen = recv(dataport.client_sock, chaDatabuf, BUFSIZE, 0); 
		printf("%s", chaDatabuf);
		memset(chaDatabuf, 0, BUFSIZE);
	}while( (nStrlen != RCV_ERROR) && (nStrlen != NOT_RCV) );

#ifdef	__LINUX_PLATFORM_DEBUG__
	printf(">>> [%s:recv_data] %d line : Out of while\n", __FILE__, __LINE__);
#endif
	close(dataport.client_sock);
}

void	recv_list(char* pBuf)
{
	int	nStrlen = 0;
	char	chaDatabuf[BUFSIZE] = {0,};

	if(pBuf == NULL)
	{
		printf(">>>[recv_list] pBuf is NULL\n");
		return;
	}
	
	do
	{
		nStrlen = recv(dataport.client_sock, chaDatabuf, BUFSIZE, 0); 

		strncat(pBuf, chaDatabuf, nStrlen);
		memset(chaDatabuf, 0, BUFSIZE);
	}while( (nStrlen != RCV_ERROR) && (nStrlen != NOT_RCV) );

#ifdef	__LINUX_PLATFORM_DEBUG__
	printf(">>> [%s:recv_data] %d line : Out of while\n", __FILE__, __LINE__);
#endif
	close(dataport.client_sock);
}
/*********************************************************************************
* Function Name	: recv_file
* Return Type		: 
* Arguments			: int nSize, char* chpFile
* Return Value		: 
* 설명				: file download
* 작성자				: Mr.Kang
* *******************************************************************************/
int recv_file(int nSize, char* chpFile)
{
	int str_len =0;
	int totalsize = 0;
	
	char file_buf[BUFSIZE];
	char* chpPathname;
	FILE *fp;

	memset(file_buf , 0, BUFSIZE);
	/* GetPathName(g_chaInputData); 2006.12.13_shahn skipped */
	
	if((fp = fopen(chpFile, "w+"))==0)
		return NOT_FILE; //Refer to ReplyCode.h

	while(totalsize < nSize)
	{
		str_len = read(dataport.client_sock, file_buf, BUFSIZE);

		if((dataport.chMode & MODE_HASH_ON) == MODE_HASH_ON)
			printf("#");	/* for displaying hash mark */
		if(str_len == -1)
		{
			printf(">>> read return -1\n\n");
			return ERROR;
		}

		fwrite(file_buf, str_len, 1, fp);
		totalsize += str_len;
	}
	if((dataport.chMode & MODE_HASH_ON) == MODE_HASH_ON)
		printf("\n");	/* for displaying hash mark */

	fclose(fp);
	close(dataport.client_sock);
}

/*********************************************************************************
* Function Name	: send_file
* Return Type		: 
* Arguments			: 
* Return Value		: 
* 설명				: file upload
* 작성자				: Mr.Kang
* *******************************************************************************/
void send_file(char* chpFile)
{
	int	str_len = 0;
	int	totalsize = 0;
	int	send_filesize = 0;

	char	file_buf[BUFSIZE];
	FILE*	fp;

	memset(file_buf, 0, BUFSIZE);
	fp = fopen(chpFile, "r");

	/* 파일위치확인 */
	fseek(fp, 0, SEEK_END);
	send_filesize = ftell(fp);
	rewind(fp); // 파일스트림을 처음으로
	while(totalsize < send_filesize)
	{
		str_len = fread(file_buf, 1, BUFSIZE, fp);
		if((dataport.chMode & MODE_HASH_ON) == MODE_HASH_ON)
			printf("#");	/* for displaying hash mark */
	
		if (str_len == -1)
		{
			printf(">>> read return -1\n\n");
			return;
		}
		
		write(dataport.client_sock, file_buf, str_len);
		totalsize += str_len;
	}
	if((dataport.chMode & MODE_HASH_ON) == MODE_HASH_ON)
		printf("\n");

	fclose(fp);
	close(dataport.client_sock);
}
																	  
